Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.server.api.rmi
Interface RemoteParameterRecorder

All Superinterfaces:
  java.rmi.Remote

    public interface RemoteParameterRecorder

extends java.rmi.Remote

Interface `RemoteParameterRecorder` manages the report parameter.

Since:
  9.0

Method Summary
`void` | `appendUsedParameter(java.lang.String userName, org.w3c.dom.Document document)` Appends the used parameter info for the specific user to his historical parameter records.
`void` | `decreaseUserParameterRecordSize(java.lang.String userName, int maxNum)` Decreases the size of the auto-complete list, and removes the previous setting.
`boolean` | `deleteReportParamList(java.lang.String userName, java.lang.String reportPath, java.lang.String reportParamListName, byte reportParamListType)` Delete parameter value list and remove it from history-parameter.xml file by specified name.
`void` | `deleteRptParameterRecords(java.lang.String report)` Deletes all used parameter records for all users for the specified report.
`void` | `deleteUserParameterRecord(java.lang.String userName)` Deletes all used parameter records for the specific user.
`boolean` | `existReportParamList(java.lang.String userName, java.lang.String reportPath, java.lang.String reportParamListName, byte reportParamListType)` Check whether the saved parameter value list existed?
`ReportParamList` | `getDefaultReportParamList(java.lang.String userName, java.lang.String reportPath)` Get user defined default saved parameter value list.
`ReportParamList` | `getReportParamList(java.lang.String userName, java.lang.String reportPath, java.lang.String reportParamListName, byte reportParamListType)` Get saved parameter value list by specified name.
`java.util.List<ReportParamList>` | `getReportParamLists(java.lang.String userName, java.lang.String reportPath, byte reportParamListType)` Get saved parameter value list collection.
`org.w3c.dom.Document` | `getUserParameterRecords(java.lang.String userName)` Gets the used parameter info for a specific user.
`boolean` | `isDontShowParamPage(java.lang.String userName, java.lang.String reportPath)` Check whether show parameter page when running report.
`void` | `modifyUsedParameter(java.lang.String userName, org.w3c.dom.Document document)` Changes the used parameter values for the specific user in his historical parameter records.
`void` | `removeUsedParameter(java.lang.String userName, org.w3c.dom.Document document)` Removes the used parameter record for the specific user from his historical parameter records.
`boolean` | `saveReportParamList(java.lang.String userName, ReportParamList reportParamList)` Save parameter value list and persist to history-parameter.xml file.
`void` | `setDontShowParamPage(java.lang.String userName, java.lang.String reportPath, boolean dontShow)` Set whether show parameter page when next running report.

Method Detail

### getUserParameterRecords

    org.w3c.dom.Document getUserParameterRecords(java.lang.String userName)
                                                 throws java.rmi.RemoteException

  Gets the used parameter info for a specific user.

  Parameters:
    `userName` - The user name, same as user ID.
  Returns:
    the used parameter value document.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### decreaseUserParameterRecordSize

    void decreaseUserParameterRecordSize(java.lang.String userName,
                                         int maxNum)
                                         throws java.rmi.RemoteException

  Decreases the size of the auto-complete list, and removes the previous setting. User sets the maximum number of auto-complete lists on the preference page. If user changes the setting number to a number that is smaller than the old setting, JReport Server should remove the previous setting and the saved values.

  Parameters:
    `userName` - The user name, same as user ID.
    `maxNum` - The maximum number of auto-complete lists on preference page.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### appendUsedParameter

    void appendUsedParameter(java.lang.String userName,
                             org.w3c.dom.Document document)
                             throws java.rmi.RemoteException

  Appends the used parameter info for the specific user to his historical parameter records.

  Parameters:
    `userName` - The user name, same as user ID.
    `document` - A set of used parameter values.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### modifyUsedParameter

    void modifyUsedParameter(java.lang.String userName,
                             org.w3c.dom.Document document)
                             throws java.rmi.RemoteException

  Changes the used parameter values for the specific user in his historical parameter records.

  Parameters:
    `userName` - The user name, same as user ID.
    `document` - A set of used parameter values.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### removeUsedParameter

    void removeUsedParameter(java.lang.String userName,
                             org.w3c.dom.Document document)
                             throws java.rmi.RemoteException

  Removes the used parameter record for the specific user from his historical parameter records.

  Parameters:
    `userName` - The user name, same as user ID.
    `document` - A set of used parameter values.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### deleteRptParameterRecords

    void deleteRptParameterRecords(java.lang.String report)
                                   throws java.rmi.RemoteException

  Deletes all used parameter records for all users for the specified report. When a report is removed from JReport Server, all historical used parameter records related with this report should be deleted.

  Parameters:
    `report` - The full path report name on resource tree, such as /SampleReports/Report1.cls.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### deleteUserParameterRecord

    void deleteUserParameterRecord(java.lang.String userName)
                                   throws java.rmi.RemoteException

  Deletes all used parameter records for the specific user. When a user ID is removed from JReport Server, all his historical used parameter records should be deleted.

  Parameters:
    `userName` - The user name, same as user ID.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.

### saveReportParamList

    boolean saveReportParamList(java.lang.String userName,
                                ReportParamList reportParamList)
                                throws java.rmi.RemoteException

  Save parameter value list and persist to history-parameter.xml file.
  - This method can be used to save manually saved parameter value list.
  - This method can be used to save automatically saved parameter value list.
  - This method can be used to save user defined default saved parameter value list.
  - The older saved parameter value list will be removed if the current user saved parameter value list size is gather the max of settings.
  - It will be modified if the parameter value list name is existed.
  - It will be added if the parameter value list name is NOT existed.
  - "name" attribute of <ReportParamList> should keep empty or remove it in this method implements if ReportParamList object is user defined default.
  - "name" attribute of <ReportParamList> should be automatically generated in this method implements if ReportParamList save type is TYPE_AUTO.
  ReportParamList object properties are corresponding with XML nodes or attributes, the detail relationship of corresponding reference `ReportParamList` class.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportParamList` - the object is a report level parameter value list, null will be ignore.
  Returns:
    If parameter value list existed or save failed, false will be return. else return true.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### existReportParamList

    boolean existReportParamList(java.lang.String userName,
                                 java.lang.String reportPath,
                                 java.lang.String reportParamListName,
                                 byte reportParamListType)
                                 throws java.rmi.RemoteException

  Check whether the saved parameter value list existed?

  Parameters:
    `userName` - the current name of user running report.
    `reportPath` - the current report resource path.
    `reportParamListName` - specified saved parameter value list name
    `reportParamListType` - specified saved parameter value list type, reference `ReportParamList.TYPE_XXXX`
  Returns:
    if specified name existed return true, else return false.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### deleteReportParamList

    boolean deleteReportParamList(java.lang.String userName,
                                  java.lang.String reportPath,
                                  java.lang.String reportParamListName,
                                  byte reportParamListType)
                                  throws java.rmi.RemoteException

  Delete parameter value list and remove it from history-parameter.xml file by specified name.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the current report resource path.
    `reportParamListName` - specified saved parameter value list name
    `reportParamListType` - specified saved parameter value list type, reference `ReportParamList.TYPE_XXXX`
  Returns:
    If parameter value list not existed or delete failed, false will be return. else return true.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### getReportParamList

    ReportParamList getReportParamList(java.lang.String userName,
                                       java.lang.String reportPath,
                                       java.lang.String reportParamListName,
                                       byte reportParamListType)
                                       throws java.rmi.RemoteException

  Get saved parameter value list by specified name.

  ReportParamList object properties are corresponding with XML nodes or attributes, the detail relationship of corresponding reference `ReportParamList` class.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the current report resource path.
    `reportParamListName` - specified saved parameter value list name, this name can be auto saved name or manual saved name.
    `reportParamListType` - specified saved parameter value list type, reference `ReportParamList.TYPE_XXXX`
  Returns:
    ReportParamList object if saved parameter value list existed, else return null.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### getDefaultReportParamList

    ReportParamList getDefaultReportParamList(java.lang.String userName,
                                              java.lang.String reportPath)
                                              throws java.rmi.RemoteException

  Get user defined default saved parameter value list.

  ReportParamList object properties are corresponding with XML nodes or attributes, the detail relationship of corresponding reference `ReportParamList` class.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the current report resource path.
  Returns:
    ReportParamList object if user defined default saved parameter value list existed, else return null.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### getReportParamLists

    java.util.List<ReportParamList> getReportParamLists(java.lang.String userName,
                                                        java.lang.String reportPath,
                                                        byte reportParamListType)
                                                        throws java.rmi.RemoteException

  Get saved parameter value list collection.

  If saved parameter type is automatically in profile settings, and will remove all manually saved parameter value list.

  If saved parameter type is manually in profile settings, and will remove all automatically saved parameter value list.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the current report resource path.
    `reportParamListType` - specified saved parameter value list type, reference `ReportParamList.TYPE_XXXX`
  Returns:
    the list of ReportParamList, order is create time descend.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### isDontShowParamPage

    boolean isDontShowParamPage(java.lang.String userName,
                                java.lang.String reportPath)
                                throws java.rmi.RemoteException

  Check whether show parameter page when running report.

  It is corresponding with "dontShowParamPage" attribute of <history-parameter> node.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the report resource path, such as "/SampleReports/Cascade Parameters.cls"
  Returns:
    if do not show parameter page, true will be return, wlse return false.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

### setDontShowParamPage

    void setDontShowParamPage(java.lang.String userName,
                              java.lang.String reportPath,
                              boolean dontShow)
                              throws java.rmi.RemoteException

  Set whether show parameter page when next running report.

  It is corresponding with "dontShowParamPage" attribute of <history-parameter> node.

  Parameters:
    `userName` - this user name is name of user current running report
    `reportPath` - the report resource path, such as "/SampleReports/Cascade Parameters.cls"
    `dontShow` - this value will be save to "dontShowParamPage" attribute of <history-parameter> node.
  Throws:
    `java.rmi.RemoteException` - if communication-related error occurs during RMI call execution.
  Since:
    V11.1Update1

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD